//
// gga.h - Grouping Genetic Algorithm
//
// author: J.I.v.Hemert
// last updated : 07-11-1997
//
// This file contains the class GGAC.
//


#ifndef GGA_H
#define GGA_H


#include <stdio.h>
#include <iomanip.h>
#include "population.h"
#include "inifile.h"
#include "timer.h"


class GGAC
{
	public:
		void Initialize (int numberofobjects, int maxevaluations, int seed = 0);
		void InitializePopulation ();
		bool Run ();
		void Close ();
		double GetTotalEvaluations ();
		double GetColorsUsed ();
	private:
		GaParamsT gaparams;
		PopulationC population;
		ofstream solutionsfile;
		ofstream datafile;
		int maxevals;
		int nrofobjects;
		int randomseed;
		bool debug;
		bool plotdata;
		bool printsolutions;
};


#endif


// eof gga.h
